FUPPES很棒的UPnP多媒體伺服器—關於mynas

fup001.jpg

關於Ubuntu這個Linux作業系統,除了做為自己一般的作業系統其能力完善,一點也不會輸給目前市面最廣為大眾所使用的Windows系列的作業系統。若談到作為伺服器或是目前正夯的家用伺服器,那對於自己來說Ubuntu無論是軟體支援或是安裝都是非常容易且實用,因此是自己不做他想的最佳選擇。
而多媒體的伺服器也是家用伺服器中重要的工作,其中UPnP多媒體伺服器就是其中方便你來分享影片和音樂的伺服器。先前在自己的mynas上使用的是mediatomb這一UPnP多媒體伺服器軟體,基本上他在作業時反應也很迅速很不錯,但是對於正體中文的支援就不是很好,因此載客端的播放軟體上總是看到許多"外星文"有時還真是不知所以然。而在試用FreeNAS時遇見他在其上使用的是FUPPES 這套UPnP多媒體伺服器,目前的版本660為最新的版本,而且他也有可以在Windows系統上使用的版本,安裝和設定上都算簡單和容易,而最重要的是他能對正體中文支援的很好不會再有不知所以然的感覺了。
若要將他安裝在Ubuntu上請在他的網站上下載fuppes-0.660.tar.gz 這個檔案,然後解開到你方便安裝使用的位置。事先做些準備之後再進入你fuppes解壓縮後的目錄夾內。

sudo apt-get remove autoconf automake gettext
sudo apt-get update
sudo apt-get install ffmpeg build-essential \ libavutil-dev libavformat-dev libavcodec-dev \ subversion libtool \ libsqlite3-dev libpcre3-dev libxml2-dev libpcre3-dev
sudo apt-get install autoconf automake gettext
cd fuppes-0.660
autoreconf –vfi
./configure –prefix=/usr
sudo make
sudo make install
sudo ldconfig

到此算是安裝完成,然後打開終端機程式輸入sudo fuppes就可以啟動FUPPES UPnP多媒體伺服器。那你會看到FUPPES啟動的情形和他所在設定網頁的網址,大致上剛開始啟動並未設定所要位址,所以基本上為 http://127.0.1.1:xxxxx所以你可依其位址去做設定或是你直接編輯它的設定檔fuppes.cfg其位置在家目錄下的隱藏目錄夾 ~.fuppes內。
當然做為家用伺服器,總是希望能直接開機後直接啟動,若還是由外面登入再啟動會有些麻煩,因此接下來設定讓他能夠開機直接啟動。

新增fuppes這位使用者及其群組,並建立心的家目錄,將原先的設定檔和資料庫檔案複製到新增位置。

sudo mkdir /etc/fuppes
sudo mkdir /var/lib/fuppes
sudo cp ~/.fuppes/fuppes.cfg /etc/fuppes
sudo cp ~/.fuppes/fuppes.db /var/lib/fuppes

sudo adduser –system –home /var/lib/fuppes –shell /bin/sh –group –no-create-home fuppes

sudo chown fuppes:fuppes /etc/fuppes/*
sudo chown -R fuppes:fuppes /var/lib/fuppes

sudo gedit /etc/init.d/fuppesd

利用管理者的權限開啟文字編輯器建立自動啟動的檔案fuppesd,並將下列的資料複製和貼上到裡面即可。

#! /bin/sh
### BEGIN INIT INFO
# Provides:          fuppesd
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      S 0 1 6
# Short-Description: UPnP Media Server
# Description:       Fuppes UPnP media server.
### END INIT INFO

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
DESC="UPnP Media Server"
NAME=fuppesd
DAEMON=`which $NAME`
DAEMON_ARGS="--config-dir /etc/fuppes/ --database-file /var/lib/fuppes/fuppes.db --log-level 1"
SCRIPTNAME=/etc/init.d/$NAME
FUPPES_USER=fuppes
FUPPES_GROUP=fuppes

# Exit if the package is not installed
if [ ! -x "$DAEMON" ]; then
{
        echo "Couldn't find $DAEMON"
        exit 99
}
fi

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --chuid $FUPPES_USER:$FUPPES_GROUP --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --chuid $FUPPES_USER:$FUPPES_GROUP --exec $DAEMON -- $DAEMON_ARGS \
		|| return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --signal 2 --retry 5 --quiet --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	return "$RETVAL"
}

case "$1" in
  start)
	log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) log_end_msg 0 ;;
		2) log_end_msg 1 ;;
	esac
	;;
  stop)
	log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) log_end_msg 0 ;;
		2) log_end_msg 1 ;;
	esac
	;;
  restart|force-reload)
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
	exit 3
	;;
esac

:
sudo chmod +x /etc/init.d/fuppesd

sudo update-rc.d fuppesd defaults 60

若一切無誤,現在就可以讓FUPPES UPnP多媒體伺服器在重新開機後自動啟動了。目前利用Ubuntu 8.10、Ubuntu 9.10和Ubuntu 10.04 alpha 2一切正常可以使用。

當然你也可以從其他位置利用終端機程式來開啟或是關閉該程式。

sudo /etc/init.d/fuppesd stop

sudo /etc/init.d/fuppesd start

fup003.jpg

附記:

上一篇貼文:日漸強大的Google Chrome瀏覽器!

張貼分享 :

Powered by Windows Live Writer

廣告

123

張貼於電腦, 軟體工具, Linux, Ubuntu, 多媒體播放工具, 伺服器
3 comments on “FUPPES很棒的UPnP多媒體伺服器—關於mynas
  1. […] 上一篇貼文: FUPPES很棒的UPnP多媒體伺服器—關於mynas […]

  2. vincent 說道:

    這篇文章真棒,受益良多,但我在Windows下用cygwin去configure它之前失敗了。我設定到autoreconfig -vfi就先失敗,command line秀出前幾步和最後錯誤的狀況:
    $ autoreconf -vfi
    autoreconf-2.65: Entering directory `.’
    autoreconf-2.65: configure.ac: not using Gettext
    autoreconf-2.65: running: aclocal –force -I m4
    configure.ac:117: warning: AC_LIB_PREPARE_PREFIX is m4_require’d but not m4_defu
    n’d
    m4/iconv.m4:9: AM_ICONV_LINKFLAGS_BODY is expanded from…
    m4/iconv.m4:20: AM_ICONV_LINK is expanded from…
    m4/iconv.m4:154: AM_ICONV is expanded from…
    configure.ac:117: the top level
    configure.ac:117: warning: AC_LIB_RPATH is m4_require’d but not m4_defun’d
    autoreconf-2.65: configure.ac: tracing
    configure.ac:117: warning: AC_LIB_PREPARE_PREFIX is m4_require’d but not m4_defu
    n’d
    ….
    ….
    configure:16422: error: possibly undefined macro: AC_LIB_RPATH
    configure:16427: error: possibly undefined macro: AC_LIB_LINKFLAGS_B
    configure:16435: error: possibly undefined macro: AC_LIB_APPENDTOVAR
    autoreconf-2.65: /usr/bin/autoconf-2.65 failed with exit status: 1

    請問大大有遇過這些問題嗎?

發表迴響

在下方填入你的資料或按右方圖示以社群網站登入:

WordPress.com Logo

您的留言將使用 WordPress.com 帳號。 登出 / 變更 )

Twitter picture

您的留言將使用 Twitter 帳號。 登出 / 變更 )

Facebook照片

您的留言將使用 Facebook 帳號。 登出 / 變更 )

Google+ photo

您的留言將使用 Google+ 帳號。 登出 / 變更 )

連結到 %s

Last.fm

Firefox Download Button
文章張貼日期
一月 2010
« 十二月   二月 »
 123
45678910
11121314151617
18192021222324
25262728293031
分類標籤
各期張貼數
貼紙標籤
HEMiDEMi
%d 位部落客按了讚: